#include <atomic>
#include <iostream>
#include <future>
#include <vector>
#include <thread>

using namespace std;

class CountingThreads {
	public:
		CountingThreads() : counter(0u) { }
		void run() {
			vector<future<unsigned long>> retVals;
			uint32_t numThreads = thread::hardware_concurrency();
			for (uint32_t t = 0; t < numThreads; ++t)
				retVals.push_back(async(launch::async, &CountingThreads::countTask, this));

			for (uint32_t t = 0; t < numThreads; ++t)
				cout<<"thread "<<t<<" returned value "<<retVals[t].get()<<endl;

			cout<<"Counting finished, final value is "<<counter<<"."<<endl;
		}

	private:
		unsigned long countTask()	{
			for (int i = 0; i < 10e6; ++i)
				counter.fetch_add(i);

			return counter.load();
		}

		atomic<unsigned long> counter;
};

int main()	{
	CountingThreads ct;
	ct.run();

	return 0;
}

